<?php

namespace app\api\controller\school\worker;


use app\common\model\school\classes\order\Order as OrderModel;
use app\common\model\school\classes\Teacher as Teachermodel;

/**
 * 员工端：课程订单管理接口
 */
class Order extends Base
{
    protected $noNeedLogin = [];
    protected $noNeedRight = '*';

    protected $model = null;

    /**
     * 初始化操作
     * @access protected
     */
    protected function _initialize()
    {

        $this->model = new OrderModel;
        parent::_initialize();

        //判断登录用户是否是员工
        $this->setUrlLock();
    }


    /**
     * @ApiTitle( 订单详情)
     * @ApiSummary(订单详情)
     * @ApiRoute(/api/school/worker/order/detail)
     * @ApiMethod(GET)
     * @ApiParams(name = "id", type = "int",required=true,description = "订单id或订单号")
     * @ApiReturn({
     *
     *})
     */
    public function detail(){
        $id = $this->request->get('id/s','');

        if(empty($id)){
            $this->error(__('缺少必要参数'));
        }

        try {
            $res =  OrderModel::getDetail($id,$this->classes_lib_ids);
            if(!$res)throw new \Exception('您无操作权限！',40003);
        } catch (\Exception $e){
//            Log::log($e->getMessage());
            $this->error($e->getMessage(),['errcode'=>$e->getCode()]);
        }
        $this->success('获取成功', ['detail' => $res]);
    }




    /**
     * @ApiTitle( 我的订单列表接口)
     * @ApiSummary(我的订单列表接口)
     * @ApiRoute(/api/school/worker/order/order_list)
     * @ApiMethod(GET)
     * @ApiParams(name = "keywords", type = "string",required=false,description = "搜索关键字")
     * @ApiParams(name = "page", type = "string",required=true,description = "页数")
     * @ApiParams(name = "limit", type = "string",required=true,description = "条数")
     * @ApiParams(name = "status", type = "string",required=false,description = "状态搜索条件：-3=已取消,0=待支付,3=使用中,6=已退款,9=已完成")
     * @ApiParams(name = "classes_lib_id", type = "int",required=false,description = "课程id")
     * @ApiReturn({
     *
     *})
     */
    public function order_list()
    {
        $user_id = 0;
        $user = $this->auth->getUser();//登录用户
        if($user)$user_id = $user['id'];
        $page  =  $this->request->get('page/d', 0); //页数
        $limit =  $this->request->get('limit/d', 0); //条数
        $keywords =  $this->request->get('keywords/s', ''); //搜索关键字
        $status =  $this->request->get('status/s', ''); //搜索关键字
        $classes_lib_id =  $this->request->get('classes_lib_id/s', ''); //搜索关键字
//        $type =  $this->request->get('type/s', ''); //筛选学员和教练单


        try{
            //当前申请状态
            $res = $this->model::workList($user_id,$page, $limit,$keywords,$status,$classes_lib_id,$this->classes_lib_ids);
//             var_dump($this->model->getLastSql());
        }catch (\Exception $e){

            $this->error($e->getMessage());
        }
        $this->success('查询成功', $res);
    }

    /**
     * @ApiTitle( 员工代操作：课程订单未支付取消接口)
     * @ApiSummary(课程订单未支付取消接口（已支付单无法取消，要走售后）)
     * @ApiRoute(/api/school/worker/order/cancel)
     * @ApiMethod(POST)
     * @ApiParams(name = "order_no", type = "string",required=true,description = "订单号")
     * @ApiReturn({
     *
     *})
     */
    public function cancel(){
        $user_id = 0;
        $user = $this->auth->getUser();//登录用户
        if($user)$user_id = $user['id'];
        $order_no =  $this->request->post('order_no/s', ''); //订单号
        try{
            //当前申请状态
            $res = $this->model->cancel($order_no,0,true,'user',$user_id,true);
        }catch (\Throwable $e){
            $this->error($e->getMessage());
        }
        $this->success('预约课时取消成功', $res);
    }



    /**
     * @ApiTitle( 我的订单数量接口)
     * @ApiSummary(返回订单各个数量)
     * @ApiRoute(/api/school/worker/order/order_count)
     * @ApiMethod(GET)
     * @ApiParams(name = "classes_lib_id", type = "int",required=false,description = "课程id")
     * @ApiReturn({
     *
     *})
     */
    public function order_count(){
        $user_id = 0;
        $user = $this->auth->getUser();//登录用户
        if($user)$user_id = $user['id'];

        $classes_lib_id =  $this->request->get('classes_lib_id/s', ''); //搜索关键字
        try{
            $res = $this->model::workCount($classes_lib_id,$this->classes_lib_ids);
        }catch (\Throwable $e){
            $this->error($e->getMessage());
        }
        $this->success('查询成功', $res);
    }



}

